{ Copyright(C) ɹ 2001-2002}
{ Programmed by Ma Bingyao }
{ Aug 20, 2002 13:23 }

program dosimg;
uses crt, dos, xstr, xdos, img;
var
  Drive, Dir, FileName, Ext:string;
  Path:string;
  Param:string;
  RootNode:PDirTreeNode;
  MainCurDrive:char;
  MainCurPath:string;
  CommandLine:string;

procedure Operation(DirNode:PDirTreeNode);
var
  FileHandle1,FileHandle2:word;
  TempPath,t:string;
  Attrib:word;
  CurPath, DirName:string;
  y:byte;

  procedure OperateIMG(Filehandle:word);
  begin
    if Pos('/L', Param)=0 then begin
      SetDefaultDrive(Path[1]);
      CD(Path);
      if Pos('/D', Param)>0 then begin
        Fsplit(DirNode^.Name,t,t,DirName,t);
        MD(DirName);
        CD(DirName);
      end;
      TextColor(LightGreen);
      Writeln('  Now Extract Files ...');
      TextColor(LightGray);
      if ExtractUnCompressIMG(FileHandle) then begin
        TextColor(LightGreen);
        Writeln('  Files Extracted successfully!');
        TextColor(LightGray);
        Writeln;
        if Pos('/D', Param)>0 then begin
          CD('..');
        end;
      end
      else begin
        TextColor(LightRed);
        Writeln('  Files Extracted failed!');
        TextColor(LightGray);
        if Pos('/D', Param)>0 then begin
          CD('..');
          RD(DirName);
        end;
      end;
    end
    else begin
      TextColor(LightGreen);
      Writeln(' Now List Files ...');
      TextColor(LightGray);
      ListUnCompressIMG(FileHandle);
    end;
    SetDefaultDrive(Drive[1]);
    CD(CurPath);
  end;

begin
  New(DirNode);
  Attrib:=archive+readonly+hidden+sysfile;
  if Pos('/S', Param)>0 then Attrib:=Attrib+directory;
  FindFirst(FileName+Ext, Attrib, DirNode);
  if not IOisOK then begin
    Dispose(DirNode);
    TextColor(LightRed);
    Writeln('Wrong filename! Check it!');
    exit;
  end;
  while IOisOK do begin
    if (DirNode^.Attr and directory)=0 then begin
      OpenFile(DirNode^.Name, FileHandle1, READ_ONLY, OPEN_FAIL);
      if IOisOK then begin
        CWD(0, CurPath);
        if CurPath='' then CurPath:=Drive+'\'
        else CurPath:=Drive+'\'+CurPath+'\';
        if Pos('/C', Param)>0 then begin
          TempPath:=DirNode^.Name;
          Fsplit(TempPath, t, t, TempPath, t);
        end;
        if IsCompressIMG(FileHandle1) then begin
          TextColor(Yellow);
          Writeln('  ', CurPath+DirNode^.Name, ' is a compress IMG file.');
          TextColor(LightGreen);
          Writeln('  Waiting for decompress it ...');
          TextColor(LightGray);
          SetDefaultDrive(MainCurDrive);
          CD(MainCurPath);
          if Pos('/C', Param)>0 then begin
            CreateFile(TempPath+'.IMA', FileHandle2, READ_WRITE, 0);
          end
          else begin
            TempPath:=GetTempDir;
            CreateTempFile(TempPath, TempPath, FileHandle2, 0);
          end;
          if DeCompressIMG(FileHandle1, FileHandle2) then
          if ISUnCompressIMG(FileHandle2) then begin
            y:=WhereY;
            gotoxy(1, y-1);
            TextColor(LightGreen);
            Writeln('  Decompressed successfully!');
            TextColor(LightGray);
            if Pos('/C', Param)=0 then begin
                OperateIMG(FileHandle2);
            end;
          end
          else begin
            y:=WhereY;
            gotoxy(1, y-1);
            TextColor(LightRed);
            Writeln('  Decompressed failed!');
            TextColor(LightGray);
          end;
          CloseFile(FileHandle2);
          if Pos('/C', Param)=0 then begin
            DeleteFile(TempPath);
          end;
        end
        else if ISUnCompressIMG(FileHandle1) then begin
          TextColor(Yellow);
          Writeln('  ', CurPath+DirNode^.Name, ' is a uncompress IMG file.');
          SetDefaultDrive(MainCurDrive);
          CD(MainCurPath);
          OperateIMG(FileHandle1);
        end
        else if IsDDI(FileHandle1) then begin
          TextColor(Yellow);
          Writeln('  ', CurPath+DirNode^.Name, ' is a DDI file.');
          TextColor(LightGreen);
          Writeln('  Waiting for change it to IMG file...');
          TextColor(LightGray);
          SetDefaultDrive(MainCurDrive);
          CD(MainCurPath);
          if Pos('/C', Param)>0 then begin
            CreateFile(TempPath+'.IMA', FileHandle2, READ_WRITE, 0);
          end
          else begin
            TempPath:=GetTempDir;
            CreateTempFile(TempPath, TempPath, FileHandle2, 0);
          end;
          if DDI2UnCompressIMG(FileHandle1, FileHandle2) then
          if ISUnCompressIMG(FileHandle2) then begin
            y:=WhereY;
            gotoxy(1, y-1);
            TextColor(LightGreen);
            Writeln('  Changed successfully!');
            TextColor(LightGray);
            if Pos('/C', Param)=0 then begin
              OperateIMG(FileHandle2);
            end;
          end
          else begin
            y:=WhereY;
            gotoxy(1, y-1);
            TextColor(LightRed);
            Writeln('  Changed failed!');
            TextColor(LightGray);
          end;
          CloseFile(FileHandle2);
          if Pos('/C', Param)=0 then begin
            DeleteFile(TempPath);
          end
        end
        else begin
          TextColor(LightRed);
          Writeln('  ', CurPath+DirNode^.Name, ' is NOT a IMG nor DDI file!');
          TextColor(LightGray);
        end;
        CloseFile(FileHandle1);
      end;
    end
    else if (DirNode^.Name[1]<>'.') then begin
      CD(DirNode^.Name);
      if IOisOK then begin
        Operation(DirNode^.Child);
        CD('..');
      end;
    end;
    FindNext(DirNode);
  end;
  dispose(DirNode);
  FindClose;
end;

{Main}
var
  i:word;
begin
  RootNode := nil;
  ClrScr;
  Writeln;
  MainCurDrive:=GetDefaultDrive;
  CWD(0, MainCurPath);
  if MainCurPath='' then MainCurPath:=MainCurDrive+':\'
  else MainCurPath:=MainCurDrive+':\'+MainCurPath;
  TextColor(LightGreen);
  Writeln('                                   DOS IMG                                   ');
  Writeln('                           Copyright(C) 2001-2002 Andot workroom Ma Bingyao  ');
  Writeln('DosIMG v1.82               Copyright(C) 2011 Roy Tam             Nov 17, 2011');
  if (ParamStr(1)='') or (ParamStr(1)='/h') or (ParamStr(1)='/H') or (ParamStr(1)='/?') then begin
    TextColor(Yellow);
    Writeln('Usage: DOSIMG filename[.IMG] [path] [/S] [/L] [/D] [/H|/?]');
    Writeln(' -or-  DOSIMG filename[.IMG] /C');
    Writeln('  filename: IMG file name, you can use wildcards.');
    Writeln('      path: Extract files to this path. default path is current path.');
    Writeln('        /S: Search sub directory.');
    Writeln('        /L: List files instead Extract files.');
    Writeln('        /D: the Directory extracted files to is named by the IMG filename.');
    Writeln('        /C: Convert compressed IMG and DDI to uncompressed IMG file.');
    Writeln('  /H or /?: Show this Help.');
    if not LFNSupport then begin
      TextColor(LightRed);
      Writeln('  You can use long filename under Windows9x/Me/2000/XP/.NET or DOS with LFNAPI');
      Writeln('support, but now you can','''','t, because there','''','s no LFNAPI support under pure DOS,');
      Writeln('but you can use short filename instead.');
    end;
  end
  else begin
    Param:='';
    if Pos('/', ParamStr(2))>0 then begin
      Path:='';
      Param:=ParamStr(2);
    end
    else Path:=ParamStr(2);
    CommandLine:='';
    for i:=1 to ParamCount do CommandLine:=CommandLine+' '+ParamStr(i);
    CommandLine:=DelLSpaces(CommandLine);
    if Pos('"',CommandLine)=1 then begin
      CommandLine:=RightStr(CommandLine,length(CommandLine)-1);
      FileName:=LeftStr(CommandLine,Pos('"',CommandLine)-1);
      if FileName='' then begin
        TextColor(LightRed);
        Writeln('Wrong filename! Check it!');
        TextColor(LightGray);
        Writeln('                                                               andot@21cn.com');
        exit;
      end;
      CommandLine:=RightStr(CommandLine,length(CommandLine)-Pos('"',CommandLine));
    end
    else begin
      FileName:=ParamStr(1);
      CommandLine:=RightStr(CommandLine,length(CommandLine)-Pos('"',CommandLine)+1);
    end;
    if Pos('"',CommandLine)>0 then begin
      CommandLine:=RightStr(CommandLine,length(CommandLine)-Pos('"',CommandLine));
      Path:=LeftStr(CommandLine,Pos('"',CommandLine)-1);
    end;
    for i:=3 to ParamCount do begin
      if Pos('/', ParamStr(i))>0 then Param:=Param+ParamStr(i);
    end;
    Param:=UpCaseStr(Param);
    if Path='' then Path:='.';
    if Pos(':',Path)=0 then Path:=MainCurDrive+':'+Path;
    MD(Path);
    GetTrueName(Path, Path);
    if not IOisOK then begin
      TextColor(LightRed);
      Writeln('Wrong Path! Check it!');
      TextColor(LightGray);
      Writeln('                                                               andot@21cn.com');
      SetDefaultDrive(MainCurDrive);
      CD(MainCurPath);
      exit;
    end;
    Fsplit(FileName, Drive, Dir, FileName, Ext);
    if Drive<>'' then SetDefaultDrive(Drive[1]) else Drive:=GetDefaultDrive+':';
    if Dir<>'' then begin
      CD(Dir);
      if not IOisOK then begin
        TextColor(LightRed);
        Writeln('Wrong filename! Check it!');
        TextColor(LightGray);
        Writeln('                                                               andot@21cn.com');
        SetDefaultDrive(MainCurDrive);
        CD(MainCurPath);
        exit;
      end;
    end;
    if FileName='' then FileName:='*';
    if Ext='' then Ext:='.IMG';
    Operation(RootNode);
  end;
  TextColor(LightGray);
  NormVideo;
  Writeln('                                                               andot@21cn.com');
  SetDefaultDrive(MainCurDrive);
  CD(MainCurPath);
end.
